<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable" ref="tableRef" :rowSelection="rowSelection">
      <!-- 行业分类 -->
      <template #form-suspect="{ model, field }">
        <a-select v-model:value="model[field]" placeholder="请选择行业分类" :fieldNames="{ label: 'text', value: 'value' }"
          :options="isSuspectOptions" @change="changeSuspect"></a-select>
      </template>
      <template #form-category="{ model, field }">
        <a-tree-select v-model:value="model[field]" show-search placeholder="请选择二级" allow-clear tree-default-expand-all
          :field-names="{ label: 'name', value: 'id', children: 'children' }" :tree-data="treeData"
          tree-node-filter-prop="label">
          <template #suffixIcon>
            <SmileOutlined />
          </template>
        </a-tree-select>
      </template>
      <!--插槽:table标题-->
      <template #tableTitle>
        <!-- <a-button type="primary" preIcon="ant-design:export-outlined" @click="onExportXls">名录导出</a-button> -->
        <!-- <a-button type="primary" preIcon="ant-design:edit-outlined" @click="handleEdit">编辑</a-button> -->
        <a-button type="primary" @click="handleEdit" v-auth="'qdml-baml-wsxx'">修改</a-button>
      </template>
      <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" />
      </template>
    </BasicTable>

    <GWrdkjbxxbModal @register="registerModal" @success="handleSuccess"></GWrdkjbxxbModal>
  </div>
</template>

<script lang="ts" name="directory-baml-baml" setup>
import { ref, computed, unref } from 'vue';
import { BasicTable, useTable, TableAction, TableActionType } from '/@/components/Table';
import { useModal } from '/@/components/Modal';
import { useListPage } from '/@/hooks/system/useListPage';
import { columns, searchFormSchema, useSuspectsData, useCategoryData } from './data';
import { BahygzList, deleteOne, batchDelete, getImportUrl, getExportUrl } from './api';
import GWrdkjbxxbModal from '../components/GWrdkjbxxbModal.vue'
import { useMessage } from '/@/hooks/web/useMessage';

const { createMessage } = useMessage()
//注册model
const [registerModal, { openModal }] = useModal();
const tableRef = ref<Nullable<TableActionType>>(null);
function getTableActionRef() {
  const tableAction = unref(tableRef);
  if (!tableAction) {
    throw new Error('tableAction is null');
  }
  return tableAction;
}
//注册table数据
const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
  tableProps: {
    title: '清单名录-备案地块清单',
    api: BahygzList,
    columns,
    canResize: false,
    //定义rowSelection的类型，默认是checkbox多选，可以设置成radio单选 
    rowKey: "wrdkid",
    rowSelection: { type: 'radio' },
    clickToRowSelect: true,
    formConfig: {
      labelWidth: 120,
      schemas: searchFormSchema,
      autoSubmitOnEnter: true,
      showAdvancedButton: false,
    },
    showIndexColumn: true,
    actionColumn: {
      width: 120,
    },
  },
  exportConfig: {
    name: '清单名录-备案地块清单',
    url: getExportUrl,
  },
  importConfig: {
    url: getImportUrl,
  },
});
const isSuspectOptions = useSuspectsData().data; // 行业分类
const useCategory = useCategoryData();
const treeData = useCategory.data; // 行业类别-数据
const changeSuspect = useCategory.changeIsSuspect; // 行业类别-方法
const [registerTable, { reload }, { rowSelection,selectedRows, selectedRowKeys }] = tableContext;
/**
 * 新增事件
 */
function handleAdd() {
  openModal(true, {
    isUpdate: false,
    showFooter: true,
  });
}
/**
 * 编辑事件
 */
 function handleEdit() {
    if (selectedRowKeys.value.length == 0) {
        createMessage.info('请选择要修改的地块');
        return
    }
    openModal(true, {
        record: selectedRows.value[0],
        isUpdate: true,
        showFooter: true,
    });
}
/**
 * 详情
 */
function handleDetail(record: Recordable) {
  openModal(true, {
    record,
    isUpdate: true,
    showFooter: false,
  });
}
/**
 * 删除事件
 */
async function handleDelete(record) {
  await deleteOne({ id: record.id }, reload);
}
/**
 * 批量删除事件
 */
async function batchHandleDelete() {
  await batchDelete({ ids: selectedRowKeys.value }, reload);
}
/**
 * 成功回调
 */
function handleSuccess() {
  selectedRows.value = []
  selectedRowKeys.value = []
  reload();
}
/**
 * 操作栏
 */
function getTableAction(record) {
  return [
    {
      label: '详情',
      onClick: handleEdit.bind(null, record),
    },
  ];
}
/**
 * 下拉操作栏
 */
function getDropDownAction(record) {
  return [
    // {
    //   label: '详情',
    //   onClick: handleDetail.bind(null, record),
    // },
    // {
    //   label: '删除',
    //   popConfirm: {
    //     title: '是否确认删除',
    //     confirm: handleDelete.bind(null, record),
    //   },
    // },
  ];
}
</script>
<style scoped></style>
